
#ifndef __EasyIPCamera_H__
#define __EasyIPCamera_H__

#include "EasyTypes.h"

#define RTSP_SERVER_NAME	"EasyIPCamera v1.3.16.1206"


typedef enum _AUTHENTICATION_TYPE_ENUM
{
	AUTHENTICATION_TYPE_BASIC = 0x00,
	AUTHENTICATION_TYPE_DIGEST,
}AUTHENTICATION_TYPE_ENUM;

typedef struct __LIVE_CHANNEL_INFO_T
{
	int		id;
	char	name[64];
}LIVE_CHANNEL_INFO_T;

typedef struct __EASY_AV_Frame
{
	Easy_U32    u32AVFrameFlag;		/* ֡־  Ƶ or Ƶ */
	Easy_U32    u32AVFrameLen;		/* ֡ĳ */
	Easy_U32    u32VFrameType;		/* ƵͣI֡P֡ */
	Easy_U8     *pBuffer;			/*  */
	Easy_U32	u32TimestampSec;	/* ʱ()*/
	Easy_U32	u32TimestampUsec;	/* ʱ(΢) */
}EASY_AV_Frame;


typedef enum __EASY_IPCAMERA_STATE_T
{
	EASY_IPCAMERA_STATE_ERROR = -1,		//ڲ
	EASY_IPCAMERA_STATE_REQUEST_MEDIA_INFO = 1,		//,media info
	EASY_IPCAMERA_STATE_REQUEST_PLAY_STREAM,						//ʼ
	EASY_IPCAMERA_STATE_REQUEST_STOP_STREAM,						//ֹͣ
}EASY_IPCAMERA_STATE_T;

/* ص userptrʾûԶ */
typedef Easy_I32(*EasyIPCamera_Callback)(Easy_I32 channelId, EASY_IPCAMERA_STATE_T channelState, EASY_MEDIA_INFO_T *mediaInfo, void *userPtr);

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef ANDROID
	Easy_API int Easy_APICALL EasyIPCamera_Activate(char *license, char* userPtr);
#else
	Easy_API int Easy_APICALL EasyIPCamera_Activate(char *license);
#endif
	/*  Rtsp Server */
	/*ü˿, صԶ */
	Easy_API Easy_I32 Easy_APICALL EasyIPCamera_Startup(Easy_U16 listenport, AUTHENTICATION_TYPE_ENUM authType, char *realm, Easy_U8 *username, Easy_U8 *password, EasyIPCamera_Callback callback, void *userptr, LIVE_CHANNEL_INFO_T *channelInfo, Easy_U32 channelNum);

	/* ֹ Rtsp Server */
	Easy_API Easy_I32 Easy_APICALL EasyIPCamera_Shutdown();

	//û      û޸û
	//ӵû,Ϊ, Ѵ,Ϊ޸
	Easy_API Easy_I32 Easy_APICALL EasyIPCamera_AddUser(const Easy_U8 *username, const Easy_U8 *password);
	//ɾû
	Easy_API Easy_I32 Easy_APICALL EasyIPCamera_DelUser(const Easy_U8 *username);

	/* frame:  巢͵֡ */
	Easy_API Easy_I32 Easy_APICALL EasyIPCamera_PushFrame(Easy_I32 channelId, EASY_AV_Frame* frame);


	Easy_API Easy_I32 Easy_APICALL EasyIPCamera_ResetChannel(Easy_I32 channelId);
#ifdef __cplusplus
}
#endif


/*
:
1.  EasyIPCamera_Startup ü˿ڡصԶָ
2. 󣬳״̬
2.1		յͻ, ص ״̬:EASY_IPCAMERA_STATE_REQUEST_MEDIA_INFO          ϲmediainfo󣬷0, EasyIpCameraӦͻok
2.2		EasyIPCameraص״̬ EASY_IPCAMERA_STATE_REQUEST_PLAY_STREAM , ʾrtsp, ʼ, ϲEasyIpCamera_PushFrame ֡
2.3		EasyIPCameraص״̬ EASY_IPCAMERA_STATE_REQUEST_STOP_STREAM , ʾͻѷteaardown, Ҫֹͣ֡
3.	 EasyIpCamera_Shutdown(), رEasyIPCameraͷԴ

*/


#endif
